# Generated by Django 4.2.13 on 2024-11-25 16:26

import api.models
from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):
    dependencies = [
        ("api", "0012_workspace_teammember_project_workspace"),
    ]

    operations = [
        migrations.CreateModel(
            name="Flow",
            fields=[
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("name", models.CharField(max_length=255)),
                ("description", models.TextField()),
                ("assistant_role", models.TextField()),
                ("metrics", models.JSONField(default=dict)),
                ("ui", models.JSONField(default=dict)),
                ("flow_graph", models.JSONField(default=dict)),
                ("published", models.BooleanField(default=False)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Plan",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[("F", "Free"), ("P", "Paid")],
                        default="F",
                        help_text="The types of a plan",
                        max_length=1,
                    ),
                ),
                (
                    "renewal_date",
                    models.DateTimeField(
                        help_text="Renewal date of the subscription", null=True
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[("A", "Active"), ("E", "Expired"), ("P", "Paused")],
                        help_text="Status of the subscription",
                        max_length=1,
                        null=True,
                    ),
                ),
                (
                    "properties",
                    models.JSONField(default=dict, help_text="Properties of the plan"),
                ),
            ],
        ),
        migrations.RemoveField(
            model_name="project",
            name="owner",
        ),
        migrations.AddField(
            model_name="chatbot",
            name="origin",
            field=models.CharField(default="default_assistant", max_length=99),
        ),
        migrations.AddField(
            model_name="document",
            name="chatbot",
            field=models.ForeignKey(
                blank=True,
                help_text="The chatbot the Document was uploaded to",
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="api.chatbot",
            ),
        ),
        migrations.AddField(
            model_name="project",
            name="config",
            field=models.JSONField(
                default=api.models.create_project_config, help_text="Guardrail settings"
            ),
        ),
        migrations.AddField(
            model_name="workspace",
            name="feature_flags",
            field=models.JSONField(
                default=dict,
                help_text="Enable/disable experimental features for workspace",
            ),
        ),
        migrations.AlterField(
            model_name="chatbot",
            name="generative_model",
            field=models.CharField(
                choices=[
                    ("anthropic/claude-3.5-sonnet", "Anthropic Claude 35 Sonnet"),
                    ("google/gemini-flash-1.5", "Google Gemini Flash 15"),
                    ("meta-llama/llama-3-70b", "Meta Llama 3 70B"),
                    (
                        "meta-llama/llama-3.1-8b-instruct:free",
                        "Meta Llama 3 8B Instruct Free",
                    ),
                    ("mistralai/mistral-7b-instruct", "Mistral 7B Instruct"),
                    ("openai/gpt-3.5-turbo", "Openai Gpt Turbo"),
                    ("openai/gpt-4o", "Openai Gpt 4O"),
                    ("qwen/qwen-2-72b-instruct", "Qwen 2 72B Instruct"),
                ],
                default="mistralai/mistral-7b-instruct",
                help_text="The generative model used by the chatbot to generate responses",
                max_length=99,
            ),
        ),
        migrations.AlterField(
            model_name="chatbot",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.CreateModel(
            name="ResponseLog",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "source",
                    models.CharField(
                        choices=[
                            ("G", "Guardrails"),
                            ("M", "Moderation"),
                            ("K", "Knowledge"),
                            ("P", "Prompt"),
                            ("F", "Flow"),
                        ],
                        help_text="The source of the message",
                        max_length=1,
                        null=True,
                    ),
                ),
                (
                    "ai_usage",
                    models.JSONField(
                        default=dict, help_text="{usage_records:list[], cost:float}"
                    ),
                ),
                (
                    "metadata",
                    models.JSONField(
                        default=dict,
                        help_text="Each service adds its own metadata with service key",
                    ),
                ),
                (
                    "context",
                    models.JSONField(
                        default=dict, help_text="Project and user context", null=True
                    ),
                ),
                (
                    "response",
                    models.ForeignKey(
                        help_text="FK to outbound message object",
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="response",
                        to="api.message",
                    ),
                ),
                (
                    "user_message",
                    models.ForeignKey(
                        help_text="FK to inbound message object that we're responding to",
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="user_message",
                        to="api.message",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="FlowRun",
            fields=[
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("P", "In-Progress"),
                            ("I", "Interrupted"),
                            ("C", "Completed"),
                        ],
                        default="P",
                        max_length=20,
                    ),
                ),
                ("current_state", models.CharField(max_length=255)),
                ("message_history", models.JSONField(default=list)),
                (
                    "chat",
                    models.ForeignKey(
                        default="",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.chat",
                    ),
                ),
                (
                    "flow",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.flow"
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="flow",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="flows",
                to="api.project",
            ),
        ),
        migrations.AddField(
            model_name="workspace",
            name="plan",
            field=models.OneToOneField(
                null=True, on_delete=django.db.models.deletion.SET_NULL, to="api.plan"
            ),
        ),
    ]
